4.20. Flag reference
Prev | Chapter 4. Using GHC | Next

## 4.20. Flag reference

This section is a quick-reference for GHC's command-line flags. For each flag, we also list its static/dynamic status (see Section 4.3, “Static, Dynamic, and Mode options”), and the flag's opposite (if available).

### 4.20.1. Verbosity options

More details in Section 4.6, “Verbosity options”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-v` | verbose mode (equivalent to `-v3`) | dynamic | -
`-v` `n` | set verbosity level | dynamic | -
`-fprint-explicit-foralls` | print explicit `forall` quantification in types | dynamic | -fno-print-explicit-foralls
`-fprint-explicit-kinds` | print explicit kind foralls and kind arguments in types | dynamic | -fno-print-explicit-kinds
`-ferror-spans` | output full span in error messages | dynamic | -
`-H` `size` | Set the minimum heap size to `size` | static | -
`-Rghc-timing` | Summarise timing stats for GHC (same as `+RTS -tstderr`) | static | -

### 4.20.2. Alternative modes of operation

More details in Section 4.5, “Modes of operation”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`--help`,`-?` | Disply help | mode | -
`--interactive` | Interactive mode - normally used by just running ghci; see Chapter 2, Using GHCi for details. | mode | -
`--make` | Build a multi-module Haskell program, automatically figuring out dependencies. Likely to be much easier, and faster, than using make; see Section 4.5.1, “Using ghc `--make`” for details.. | mode | -
`-e `expr`` | Evaluate `expr`; see Section 4.5.2, “Expression evaluation mode” for details. | mode | -
`--show-iface` | Display the contents of an interface file. | mode | -
`-M` | Generate dependency information suitable for use in a `Makefile`; see Section 4.7.11, “Dependency generation” for details. | mode | -
`--supported-extensions`, `--supported-languages` | display the supported language extensions | mode | -
`--show-options` | display the supported command line options | mode | -
`--info` | display information about the compiler | mode | -
`--version, -V` | display GHC version | mode | -
`--numeric-version` | display GHC version (numeric only) | mode | -
`--print-libdir` | display GHC library directory | mode | -

### 4.20.3. Which phases to run

Section 4.5.3, “Batch compiler mode”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-E` | Stop after preprocessing (`.hspp` file) | mode | -
`-C` | Stop after generating C (`.hc` file) | mode | -
`-S` | Stop after generating assembly (`.s` file) | mode | -
`-c` | Do not link | dynamic | -
`-x` `suffix` | Override default behaviour for source files | static | -

### 4.20.4. Redirecting output

Section 4.7.4, “Redirecting the compilation output(s)”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-hcsuf` `suffix` | set the suffix to use for intermediate C files | dynamic | -
`-hidir` `dir` | set directory for interface files | dynamic | -
`-hisuf` `suffix` | set the suffix to use for interface files | dynamic | -
`-o` `filename` | set output filename | dynamic | -
`-odir` `dir` | set directory for object files | dynamic | -
`-ohi` `filename` | set the filename in which to put the interface | dynamic |
`-osuf` `suffix` | set the output file suffix | dynamic | -
`-stubdir` `dir` | redirect FFI stub files | dynamic | -
`-dumpdir` `dir` | redirect dump files | dynamic | -
`-outputdir` `dir` | set output directory | dynamic | -

### 4.20.5. Keeping intermediate files

Section 4.7.5, “Keeping Intermediate Files”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-keep-hc-file` or `-keep-hc-files` | retain intermediate `.hc` files | dynamic | -
`-keep-llvm-file` or `-keep-llvm-files` | retain intermediate LLVM `.ll` files | dynamic | -
`-keep-s-file` or `-keep-s-files` | retain intermediate `.s` files | dynamic | -
`-keep-tmp-files` | retain all intermediate temporary files | dynamic | -

### 4.20.6. Temporary files

Section 4.7.6, “Redirecting temporary files”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-tmpdir` | set the directory for temporary files | dynamic | -

### 4.20.7. Finding imports

Section 4.7.3, “The search path”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-i` `dir1`:`dir2`:... | add `dir`, `dir2`, etc. to import path | static/`:set` | -
`-i` | Empty the import directory list | static/`:set` | -

### 4.20.8. Interface file options

Section 4.7.7, “Other options related to interface files”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-ddump-hi` | Dump the new interface to stdout | dynamic | -
`-ddump-hi-diffs` | Show the differences vs. the old interface | dynamic | -
`-ddump-minimal-imports` | Dump a minimal set of imports | dynamic | -
`--show-iface` `file` | See Section 4.5, “Modes of operation”. |  |

### 4.20.9. Recompilation checking

Section 4.7.8, “The recompilation checker”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-fforce-recomp` | Turn off recompilation checking. This is implied by any `-ddump-X` option when compiling a single file (i.e. when using `-c`). | dynamic | `-fno-force-recomp`

### 4.20.10. Interactive-mode options

Section 2.9, “The `.ghci` file”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-ignore-dot-ghci` | Disable reading of `.ghci` files | dynamic | -
`-ghci-script` | Read additional `.ghci` files | dynamic | -
`-fbreak-on-exception` | Break on any exception thrown | dynamic | `-fno-break-on-exception`
`-fbreak-on-error` | Break on uncaught exceptions and errors | dynamic | `-fno-break-on-error`
`-fghci-hist-size=`n`` | Set the number of entries GHCi keeps for `:history` | dynamic | `(default is 50)`
`-fprint-evld-with-show` | Enable usage of Show instances in `:print` | dynamic | `-fno-print-evld-with-show`
`-fprint-bind-result` | Turn on printing of binding results in GHCi | dynamic | `-fno-print-bind-result`
`-fno-print-bind-contents` | Turn off printing of binding contents in GHCi | dynamic | -
`-fno-implicit-import-qualified` | Turn off implicit qualified import of everything in GHCi | dynamic | -
`-interactive-print` | Select the function to use for printing evaluated expressions in GHCi | dynamic | -

### 4.20.11. Packages

Section 4.9, “ Packages ”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-package-name` `P` | Compile to be part of package `P` | static | -
`-package` `P` | Expose package `P` | static/`:set` | -
`-hide-all-packages` | Hide all packages by default | static | -
`-hide-package` `name` | Hide package `P` | static/`:set` | -
`-ignore-package` `name` | Ignore package `P` | static/`:set` | -
`-package-db` `file` | Add `file` to the package db stack. | static | -
`-clear-package-db` | Clear the package db stack. | static | -
`-no-global-package-db` | Remove the global package db from the stack. | static | -
`-global-package-db` | Add the global package db to the stack. | static | -
`-no-user-package-db` | Remove the user's package db from the stack. | static | -
`-user-package-db` | Add the user's package db to the stack. | static | -
`-no-auto-link-packages` | Don't automatically link in the base and rts packages. | dynamic | -
`-trust` `P` | Expose package `P` and set it to be trusted | static/`:set` | -
`-distrust` `P` | Expose package `P` and set it to be distrusted | static/`:set` | -
`-distrust-all` | Distrust all packages by default | static/`:set` | -

### 4.20.12. Language options

Language options can be enabled either by a command-line option `-Xblah`, or by a `{-# LANGUAGE blah #-}` pragma in the file itself. See Section 7.1, “Language options”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-fglasgow-exts` | Deprecated. Enable most language extensions; see Section 7.1, “Language options” for exactly which ones. | dynamic | `-fno-glasgow-exts`
`-firrefutable-tuples` | Make tuple pattern matching irrefutable | dynamic | `-fno-irrefutable-tuples`
`-fcontext-stack=N` `n` | set the limit for context reduction. Default is 20. | dynamic |
`-ftype-function-depth=N` `n` | set the limit for type function reductions. Default is 200. | dynamic |
`-XAllowAmbiguousTypes` | Allow the user to write ambiguous types, and the type inference engine to infer them. | dynamic | `-XNoAllowAmbiguousTypes`
`-XArrows` | Enable arrow notation extension | dynamic | `-XNoArrows`
`-XAutoDeriveTypeable` | Automatically derive Typeable instances for every datatype and type class declaration. Implies `-XDeriveDataTypeable`. | dynamic | `-XNoAutoDeriveTypeable`
`-XConstraintKinds` | Enable a kind of constraints. | dynamic | `-XNoConstraintKinds`
`-XDataKinds` | Enable datatype promotion. | dynamic | `-XNoDataKinds`
`-XDeriveDataTypeable` | Enable deriving for the Data and Typeable classes. | dynamic | `-XNoDeriveDataTypeable`
`-XDeriveGeneric` | Enable deriving for the Generic class. | dynamic | `-XNoDeriveGeneric`
`-XGeneralizedNewtypeDeriving` | Enable newtype deriving. | dynamic | `-XNoGeneralizedNewtypeDeriving`
`-XDisambiguateRecordFields` | Enable record field disambiguation | dynamic | `-XNoDisambiguateRecordFields`
`-XEmptyCase` | Allow empty case alternatives | dynamic | `-XNoEmptyCase`
`-XExtendedDefaultRules` | Use GHCi's extended default rules in a normal module | dynamic | `-XNoExtendedDefaultRules`
`-XForeignFunctionInterface` | Enable foreign function interface. | dynamic | `-XNoForeignFunctionInterface`
`-XGADTs` | Enable generalised algebraic data types. | dynamic | `-XNoGADTs`
`-XGADTSyntax` | Enable generalised algebraic data type syntax. | dynamic | `-XNoGADTSyntax`
`-XGenerics` | Deprecated, does nothing. No longer enables generic classes. See also GHC's support for generic programming. | dynamic | `-XNoGenerics`
`-XImplicitParams` | Enable Implicit Parameters. | dynamic | `-XNoImplicitParams`
`-XNoImplicitPrelude` | Don't implicitly `import Prelude` | dynamic | `-XImplicitPrelude`
`-XIncoherentInstances` | Enable incoherent instances. Implies `-XOverlappingInstances` | dynamic | `-XNoIncoherentInstances`
`-XNoMonomorphismRestriction` | Disable the monomorphism restriction | dynamic | `-XMonomorphismRrestriction`
`-XNegativeLiterals` | Enable support for negative literals | dynamic | `-XNoNegativeLiterals`
`-XNoNPlusKPatterns` | Disable support for `n+k` patterns | dynamic | `-XNPlusKPatterns`
`-XNumDecimals` | Enable support for 'fractional' integer literals | dynamic | `-XNoNumDecimals`
`-XOverlappingInstances` | Enable overlapping instances | dynamic | `-XNoOverlappingInstances`
`-XOverloadedLists` | Enable overloaded lists. | dynamic | `-XNoOverloadedLists`
`-XOverloadedStrings` | Enable overloaded string literals. | dynamic | `-XNoOverloadedStrings`
`-XQuasiQuotes` | Enable quasiquotation. | dynamic | `-XNoQuasiQuotes`
`-XRelaxedPolyRec` | Relaxed checking for mutually-recursive polymorphic functions | dynamic | `-XNoRelaxedPolyRec`
`-XNoTraditionalRecordSyntax` | Disable support for traditional record syntax (as supported by Haskell 98) `C {f = x}` | dynamic | `-XTraditionalRecordSyntax`
`-XTypeFamilies` | Enable type families. | dynamic | `-XNoTypeFamilies`
`-XUndecidableInstances` | Enable undecidable instances | dynamic | `-XNoUndecidableInstances`
`-XPolyKinds` | Enable kind polymorphism. Implies `-XKindSignatures`. | dynamic | `-XNoPolyKinds`
`-XMonoLocalBinds` | Enable do not generalise local bindings. Implied by `-XTypeFamilies` and `-XGADTs`. | dynamic | `-XNoMonoLocalBinds`
`-XRebindableSyntax` | Employ rebindable syntax | dynamic | `-XNoRebindableSyntax`
`-XScopedTypeVariables` | Enable lexically-scoped type variables. | dynamic | `-XNoScopedTypeVariables`
`-XTemplateHaskell` | Enable Template Haskell. | dynamic | `-XNoTemplateHaskell`
`-XBangPatterns` | Enable bang patterns. | dynamic | `-XNoBangPatterns`
`-XCPP` | Enable the C preprocessor. | dynamic | `-XNoCPP`
`-XPatternGuards` | Enable pattern guards. | dynamic | `-XNoPatternGuards`
`-XViewPatterns` | Enable view patterns. | dynamic | `-XNoViewPatterns`
`-XUnicodeSyntax` | Enable unicode syntax. | dynamic | `-XNoUnicodeSyntax`
`-XMagicHash` | Allow "#" as a postfix modifier on identifiers. | dynamic | `-XNoMagicHash`
`-XExplicitForAll` | Enable explicit universal quantification. Implied by `-XScopedTypeVariables`, `-XLiberalTypeSynonyms`, `-XRankNTypes`, `-XExistentialQuantification` | dynamic | `-XNoExplicitForAll`
`-XPolymorphicComponents` | Enable polymorphic components for data constructors. | dynamic, synonym for `-XRankNTypes` | `-XNoPolymorphicComponents`
`-XRank2Types` | Enable rank-2 types. | dynamic, synonym for `-XRankNTypes` | `-XNoRank2Types`
`-XRankNTypes` | Enable rank-N types. | dynamic | `-XNoRankNTypes`
`-XImpredicativeTypes` | Enable impredicative types. | dynamic | `-XNoImpredicativeTypes`
`-XExistentialQuantification` | Enable existential quantification. | dynamic | `-XNoExistentialQuantification`
`-XKindSignatures` | Enable kind signatures. | dynamic | `-XNoKindSignatures`
`-XEmptyDataDecls` | Enable empty data declarations. | dynamic | `-XNoEmptyDataDecls`
`-XParallelListComp` | Enable parallel list comprehensions. | dynamic | `-XNoParallelListComp`
`-XTransformListComp` | Enable generalised list comprehensions. | dynamic | `-XNoTransformListComp`
`-XMonadComprehensions` | Enable monad comprehensions. | dynamic | `-XNoMonadComprehensions`
`-XUnliftedFFITypes` | Enable unlifted FFI types. | dynamic | `-XNoUnliftedFFITypes`
`-XInterruptibleFFI` | Enable interruptible FFI. | dynamic | `-XNoInterruptibleFFI`
`-XLiberalTypeSynonyms` | Enable liberalised type synonyms. | dynamic | `-XNoLiberalTypeSynonyms`
`-XTypeOperators` | Enable type operators. | dynamic | `-XNoTypeOperators`
`-XExplicitNamespaces` | Enable using the keyword `type` to specify the namespace of entries in imports and exports (Section 7.3.27, “Explicit namespaces in import/export”). Implied by `-XTypeOperators` and `-XTypeFamilies`. | dynamic | `-XNoExplicitNamespaces`
`-XRecursiveDo` | Enable recursive do (mdo) notation. | dynamic | `-XNoRecursiveDo`
`-XParallelArrays` | Enable parallel arrays. | dynamic | `-XNoParallelArrays`
`-XRecordWildCards` | Enable record wildcards. | dynamic | `-XNoRecordWildCards`
`-XNamedFieldPuns` | Enable record puns. | dynamic | `-XNoNamedFieldPuns`
`-XDisambiguateRecordFields` | Enable record field disambiguation. | dynamic | `-XNoDisambiguateRecordFields`
`-XUnboxedTuples` | Enable unboxed tuples. | dynamic | `-XNoUnboxedTuples`
`-XStandaloneDeriving` | Enable standalone deriving. | dynamic | `-XNoStandaloneDeriving`
`-XTypeSynonymInstances` | Enable type synonyms in instance heads. | dynamic | `-XNoTypeSynonymInstances`
`-XFlexibleContexts` | Enable flexible contexts. | dynamic | `-XNoFlexibleContexts`
`-XFlexibleInstances` | Enable flexible instances. Implies `-XTypeSynonymInstances` | dynamic | `-XNoFlexibleInstances`
`-XConstrainedClassMethods` | Enable constrained class methods. | dynamic | `-XNoConstrainedClassMethods`
`-XDefaultSignatures` | Enable default signatures. | dynamic | `-XNoDefaultSignatures`
`-XMultiParamTypeClasses` | Enable multi parameter type classes. | dynamic | `-XNoMultiParamTypeClasses`
`-XNullaryTypeClasses` | Enable nullary (no parameter) type classes. | dynamic | `-XNoNullaryTypeClasses`
`-XFunctionalDependencies` | Enable functional dependencies. | dynamic | `-XNoFunctionalDependencies`
`-XPackageImports` | Enable package-qualified imports. | dynamic | `-XNoPackageImports`
`-XLambdaCase` | Enable lambda-case expressions. | dynamic | `-XNoLambdaCase`
`-XMultiWayIf` | Enable multi-way if-expressions. | dynamic | `-XNoMultiWayIf`
`-XSafe` | Enable the Safe Haskell Safe mode. | dynamic | `-`
`-XTrustworthy` | Enable the Safe Haskell Trustworthy mode. | dynamic | `-`
`-XUnsafe` | Enable Safe Haskell Unsafe mode. | dynamic | `-`
`-fpackage-trust` | Enable Safe Haskell trusted package requirement for trustworthy modules. | dynamic | `-`

### 4.20.13. Warnings

Section 4.8, “Warnings and sanity-checking”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-W` | enable normal warnings | dynamic | `-w`
`-w` | disable all warnings | dynamic | -
`-Wall` | enable almost all warnings (details in Section 4.8, “Warnings and sanity-checking”) | dynamic | `-w`
`-Werror` | make warnings fatal | dynamic | -Wwarn
`-Wwarn` | make warnings non-fatal | dynamic | -Werror
`-fdefer-type-errors` | Defer as many type errors as possible until runtime. | dynamic | `-fno-defer-type-errors`
`-fhelpful-errors` | Make suggestions for mis-spelled names. | dynamic | `-fno-helpful-errors`
`-fwarn-deprecated-flags` | warn about uses of commandline flags that are deprecated | dynamic | `-fno-warn-deprecated-flags`
`-fwarn-duplicate-constraints` | warn when a constraint appears duplicated in a type signature | dynamic | `-fno-warn-duplicate-constraints`
`-fwarn-duplicate-exports` | warn when an entity is exported multiple times | dynamic | `-fno-warn-duplicate-exports`
`-fwarn-hi-shadowing` | warn when a `.hi` file in the current directory shadows a library | dynamic | `-fno-warn-hi-shadowing`
`-fwarn-identities` | warn about uses of Prelude numeric conversions that are probably the identity (and hence could be omitted) | dynamic | `-fno-warn-identities`
`-fwarn-implicit-prelude` | warn when the Prelude is implicitly imported | dynamic | `-fno-warn-implicit-prelude`
`-fwarn-incomplete-patterns` | warn when a pattern match could fail | dynamic | `-fno-warn-incomplete-patterns`
`-fwarn-incomplete-uni-patterns` | warn when a pattern match in a lambda expression or pattern binding could fail | dynamic | `-fno-warn-incomplete-uni-patterns`
`-fwarn-incomplete-record-updates` | warn when a record update could fail | dynamic | `-fno-warn-incomplete-record-updates`
`-fwarn-lazy-unlifted-bindings` | (deprecated) warn when a pattern binding looks lazy but must be strict | dynamic | `-fno-warn-lazy-unlifted-bindings`
`-fwarn-missing-fields` | warn when fields of a record are uninitialised | dynamic | `-fno-warn-missing-fields`
`-fwarn-missing-import-lists` | warn when an import declaration does not explicitly list all the names brought into scope | dynamic | `-fnowarn-missing-import-lists`
`-fwarn-missing-methods` | warn when class methods are undefined | dynamic | `-fno-warn-missing-methods`
`-fwarn-missing-signatures` | warn about top-level functions without signatures | dynamic | `-fno-warn-missing-signatures`
`-fwarn-missing-local-sigs` | warn about polymorphic local bindings without signatures | dynamic | `-fno-warn-missing-local-sigs`
`-fwarn-monomorphism-restriction` | warn when the Monomorphism Restriction is applied | dynamic | `-fno-warn-monomorphism-restriction`
`-fwarn-name-shadowing` | warn when names are shadowed | dynamic | `-fno-warn-name-shadowing`
`-fwarn-orphans, -fwarn-auto-orphans` | warn when the module contains orphan instance declarations or rewrite rules | dynamic | `-fno-warn-orphans, -fno-warn-auto-orphans`
`-fwarn-overlapping-patterns` | warn about overlapping patterns | dynamic | `-fno-warn-overlapping-patterns`
`-fwarn-tabs` | warn if there are tabs in the source file | dynamic | `-fno-warn-tabs`
`-fwarn-type-defaults` | warn when defaulting happens | dynamic | `-fno-warn-type-defaults`
`-fwarn-unrecognised-pragmas` | warn about uses of pragmas that GHC doesn't recognise | dynamic | `-fno-warn-unrecognised-pragmas`
`-fwarn-unused-binds` | warn about bindings that are unused | dynamic | `-fno-warn-unused-binds`
`-fwarn-unused-imports` | warn about unnecessary imports | dynamic | `-fno-warn-unused-imports`
`-fwarn-unused-matches` | warn about variables in patterns that aren't used | dynamic | `-fno-warn-unused-matches`
`-fwarn-unused-do-bind` | warn about do bindings that appear to throw away values of types other than `()` | dynamic | `-fno-warn-unused-do-bind`
`-fwarn-wrong-do-bind` | warn about do bindings that appear to throw away monadic values that you should have bound instead | dynamic | `-fno-warn-wrong-do-bind`
`-fwarn-unsafe` | warn if the module being compiled is regarded to be unsafe. Should be used to check the safety status of modules when using safe inference. | dynamic | `-fno-warn-unsafe`
`-fwarn-safe` | warn if the module being compiled is regarded to be safe. Should be used to check the safety status of modules when using safe inference. | dynamic | `-fno-warn-safe`
`-fwarn-warnings-deprecations` | warn about uses of functions & types that have warnings or deprecated pragmas | dynamic | `-fno-warn-warnings-deprecations`
`-fwarn-amp` | warn on definitions conflicting with the Applicative-Monad Proposal (AMP) | dynamic | `-fno-warn-amp`
`-fwarn-typed-holes` | Enable holes in expressions. | dynamic | `-fno-warn-typed-holes`

### 4.20.14. Optimisation levels

These options are described in more detail in Section 4.10, “Optimisation (code improvement)”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-O` | Enable default optimisation (level 1) | dynamic | `-O0`
`-O` `n` | Set optimisation level `n` | dynamic | `-O0`

### 4.20.15. Individual optimisations

These options are described in more detail in Section 4.10.2, “`-f*`: platform-independent flags”.

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-fcase-merge` | Enable case-merging. Implied by `-O`. | dynamic | `-fno-case-merge`
`-fcse` | Turn on common sub-expression elimination. Implied by `-O`. | dynamic | `-fno-cse`
`-fdicts-strict` | Make dictionaries strict | static | `-fno-dicts-strict`
`-fdo-eta-reduction` | Enable eta-reduction. Implied by `-O`. | dynamic | `-fno-do-eta-reduction`
`-fdo-lambda-eta-expansion` | Enable lambda eta-reduction | dynamic | `-fno-do-lambda-eta-expansion`
`-feager-blackholing` | Turn on eager blackholing | dynamic | -
`-fenable-rewrite-rules` | Switch on all rewrite rules (including rules generated by automatic specialisation of overloaded functions). Implied by `-O`. | dynamic | `-fno-enable-rewrite-rules`
`-fvectorise` | Enable vectorisation of nested data parallelism | dynamic | `-fno-vectorise`
`-favoid-vect` | Enable vectorisation avoidance (EXPERIMENTAL) | dynamic | `-fno-avoid-vect`
`-fexcess-precision` | Enable excess intermediate precision | dynamic | `-fno-excess-precision`
`-ffloat-in` | Turn on the float-in transformation. Implied by `-O`. | dynamic | `-fno-float-in`
`-ffull-laziness` | Turn on full laziness (floating bindings outwards). Implied by `-O`. | dynamic | `-fno-full-laziness`
`-ffun-to-thunk` | Allow worker-wrapper to convert a function closure into a thunk if the function does not use any of its arguments. Off by default. | dynamic | `-fno-fun-to-thunk`
`-fignore-asserts` | Ignore assertions in the source | dynamic | `-fno-ignore-asserts`
`-fignore-interface-pragmas` | Ignore pragmas in interface files | dynamic | `-fno-ignore-interface-pragmas`
`-floopification` | Turn saturated self-recursive tail-calls into local jumps in the generated assembly. | dynamic | `-fno-loopification`
`-flate-dmd-anal` | Run demand analysis again, at the end of the simplification pipeline | dynamic | `-fno-late-dmd-anal`
`-fliberate-case` | Turn on the liberate-case transformation. Implied by `-O2`. | dynamic | -fno-liberate-case
`-fliberate-case-threshold`=`n` | Set the size threshold for the liberate-case transformation to `n` (default: 200) | static | `-fno-liberate-case-threshold`
`-fmax-relevant-bindings=N` | Set the maximum number of bindings to display in type error messages (default 6). | dynamic | `-fno-max-relevant-bindings`
`-fmax-simplifier-iterations=N` | Set the max iterations for the simplifier | dynamic | -
`-fmax-worker-args=N` | If a worker has that many arguments, none will be unpacked anymore (default: 10) | dynamic | -
`-fno-opt-coercion` | Turn off the coercion optimiser | static | -
`-fno-pre-inlining` | Turn off pre-inlining | dynamic | -
`-fno-state-hack` | Turn off the "state hack" whereby any lambda with a real-world state token as argument is considered to be single-entry. Hence OK to inline things inside it. | static | -
`-fpedantic-bottoms` | Make GHC be more precise about its treatment of bottom (but see also `-fno-state-hack`). In particular, GHC will not eta-expand through a case expression. | dynamic | `-fno-pedantic-bottoms`
`-fomit-interface-pragmas` | Don't generate interface pragmas | dynamic | `-fno-omit-interface-pragmas`
`-fsimplifier-phases` | Set the number of phases for the simplifier (default 2). Ignored with `-O0`. | dynamic | -
`-fsimpl-tick-factor=`n`` | Set the percentage factor for simplifier ticks (default 100) | dynamic | -
`-fspec-constr` | Turn on the SpecConstr transformation. Implied by `-O2`. | dynamic | `-fno-spec-constr`
`-fspec-constr-threshold`=`n` | Set the size threshold for the SpecConstr transformation to `n` (default: 200) | static | `-fno-spec-constr-threshold`
`-fspec-constr-count`=`n` | Set to `n` (default: 3) the maximum number of specialisations that will be created for any one function by the SpecConstr transformation | static | `-fno-spec-constr-count`
`-fspecialise` | Turn on specialisation of overloaded functions. Implied by `-O`. | dynamic | `-fno-specialise`
`-fstrictness` | Turn on strictness analysis. Implied by `-O`. | dynamic | `-fno-strictness`
`-fstrictness=before`=`n` | Run an additional strictness analysis before simplifier phase `n` | dynamic | -
`-fstatic-argument-transformation` | Turn on the static argument transformation. Implied by `-O2`. | dynamic | `-fno-static-argument-transformation`
`-funbox-strict-fields` | Flatten strict constructor fields | dynamic | `-fno-unbox-strict-fields`
`-funbox-small-strict-fields` | Flatten strict constructor fields with a pointer-sized representation | dynamic | `-fno-unbox-small-strict-fields`
`-funfolding-creation-threshold` | Tweak unfolding settings | dynamic | `-fno-unfolding-creation-threshold`
`-funfolding-fun-discount` | Tweak unfolding settings | dynamic | `-fno-unfolding-fun-discount`
`-funfolding-keeness-factor` | Tweak unfolding settings | dynamic | `-fno-unfolding-keeness-factor`
`-funfolding-use-threshold` | Tweak unfolding settings | dynamic | `-fno-unfolding-use-threshold`

### 4.20.16. Profiling options

Chapter 5, Profiling

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-prof` | Turn on profiling | static | -
`-fprof-auto` | Auto-add `SCC`s to all bindings not marked INLINE | dynamic | `-fno-prof-auto`
`-fprof-auto-top` | Auto-add `SCC`s to all top-level bindings not marked INLINE | dynamic | `-fno-prof-auto`
`-fprof-auto-exported` | Auto-add `SCC`s to all exported bindings not marked INLINE | dynamic | `-fno-prof-auto`
`-fprof-cafs` | Auto-add `SCC`s to all CAFs | dynamic | `-fno-prof-cafs`
`-fno-prof-count-entries` | Do not collect entry counts | dynamic | `-fprof-count-entries`
`-ticky` | Turn on ticky-ticky profiling | static | -

### 4.20.17. Program coverage options

Section 5.7, “Observing Code Coverage”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-fhpc` | Turn on Haskell program coverage instrumentation | dynamic | `-`
`-hpcdir dir` | Directory to deposit .mix files during compilation (default is .hpc) | dynamic | `-`

### 4.20.18. Haskell pre-processor options

Section 4.12.4, “Options affecting a Haskell pre-processor”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-F` | Enable the use of a pre-processor (set with `-pgmF`) | dynamic | -

### 4.20.19. C pre-processor options

Section 4.12.3, “Options affecting the C pre-processor”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-cpp` | Run the C pre-processor on Haskell source files | dynamic | -
`-D` `symbol`[=`value`] | Define a symbol in the C pre-processor | dynamic | `-U` `symbol`
`-U` `symbol` | Undefine a symbol in the C pre-processor | dynamic | -
`-I` `dir` | Add `dir` to the directory search list for `#include` files | dynamic | -

### 4.20.20. Code generation options

Section 4.12.5, “Options affecting code generation”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-fasm` | Use the native code generator | dynamic | -fllvm
`-fllvm` | Compile using the LLVM code generator | dynamic | -fasm
`-fno-code` | Omit code generation | dynamic | -
`-fbyte-code` | Generate byte-code | dynamic | -
`-fobject-code` | Generate object code | dynamic | -

### 4.20.21. Linking options

Section 4.12.6, “Options affecting linking”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-shared` | Generate a shared library (as opposed to an executable) | dynamic | -
`-staticlib` | On Darwin/OS X/iOS only, generate a standalone static library (as opposed to an executable). This is the usual way to compile for iOS. | dynamic | -
`-fPIC` | Generate position-independent code (where available) | dynamic | -
`-dynamic` | Use dynamic Haskell libraries (if available) | static | -
`-dynamic-too` | Build dynamic object files as well as static object files during compilation | static | -
`-dyno` | Set the output path for the dynamically linked objects | static | -
`-dynosuf` | Set the output suffix for dynamic object files | static | -
`-dynload` | Selects one of a number of modes for finding shared libraries at runtime. | static | -
`-framework` `name` | On Darwin/OS X/iOS only, link in the framework `name`. This option corresponds to the `-framework` option for Apple's Linker. | dynamic | -
`-framework-path` `name` | On Darwin/OS X/iOS only, add `dir` to the list of directories searched for frameworks. This option corresponds to the `-F` option for Apple's Linker. | dynamic | -
`-l` `lib` | Link in library `lib` | dynamic | -
`-L` `dir` | Add `dir` to the list of directories searched for libraries | dynamic | -
`-main-is` | Set main module and function | dynamic | -
`--mk-dll` | DLL-creation mode (Windows only) | dynamic | -
`-no-hs-main` | Don't assume this program contains `main` | dynamic | -
`-rtsopts`, `-rtsopts={none,some,all}` | Control whether the RTS behaviour can be tweaked via command-line flags and the `GHCRTS` environment variable. Using `none` means no RTS flags can be given; `some` means only a minimum of safe options can be given (the default), and `all` (or no argument at all) means that all RTS flags are permitted. | dynamic | -
`-with-rtsopts=`opts`` | Set the default RTS options to `opts`. | dynamic | -
`-no-link` | Omit linking | dynamic | -
`-split-objs` | Split objects (for libraries) | dynamic | -
`-static` | Use static Haskell libraries | static | -
`-threaded` | Use the threaded runtime | static | -
`-debug` | Use the debugging runtime | static | -
`-eventlog` | Enable runtime event tracing | static | -
`-fno-gen-manifest` | Do not generate a manifest file (Windows only) | dynamic | -
`-fno-embed-manifest` | Do not embed the manifest in the executable (Windows only) | dynamic | -
`-fno-shared-implib` | Don't generate an import library for a DLL (Windows only) | dynamic | -
`-dylib-install-name` `path` | Set the install name (via `-install_name` passed to Apple's linker), specifying the full install path of the library file. Any libraries or executables that link with it later will pick up that path as their runtime search location for it. (Darwin/OS X only) | dynamic | -

### 4.20.22. Plugin options

Section 9.3, “Compiler Plugins”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-fplugin`=`module` | Load a plugin exported by a given module | static | -
`-fplugin-opt`=`module:args` | Give arguments to a plugin module; module must be specified with `-fplugin` | static | -

### 4.20.23. Replacing phases

Section 4.12.1, “Replacing the program for one or more phases”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-pgmL` `cmd` | Use `cmd` as the literate pre-processor | dynamic | -
`-pgmP` `cmd` | Use `cmd` as the C pre-processor (with `-cpp` only) | dynamic | -
`-pgmc` `cmd` | Use `cmd` as the C compiler | dynamic | -
`-pgms` `cmd` | Use `cmd` as the splitter | dynamic | -
`-pgma` `cmd` | Use `cmd` as the assembler | dynamic | -
`-pgml` `cmd` | Use `cmd` as the linker | dynamic | -
`-pgmdll` `cmd` | Use `cmd` as the DLL generator | dynamic | -
`-pgmF` `cmd` | Use `cmd` as the pre-processor (with `-F` only) | dynamic | -
`-pgmwindres` `cmd` | Use `cmd` as the program for embedding manifests on Windows. | dynamic | -
`-pgmlibtool` `cmd` | Use `cmd` as the command for libtool (with `-staticlib` only). | dynamic | -

### 4.20.24. Forcing options to particular phases

Section 4.12.2, “Forcing options to a particular phase”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-optL` `option` | pass `option` to the literate pre-processor | dynamic | -
`-optP` `option` | pass `option` to cpp (with `-cpp` only) | dynamic | -
`-optF` `option` | pass `option` to the custom pre-processor | dynamic | -
`-optc` `option` | pass `option` to the C compiler | dynamic | -
`-optlo` `option` | pass `option` to the LLVM optimiser | dynamic | -
`-optlc` `option` | pass `option` to the LLVM compiler | dynamic | -
`-optm` `option` | pass `option` to the mangler | dynamic | -
`-opta` `option` | pass `option` to the assembler | dynamic | -
`-optl` `option` | pass `option` to the linker | dynamic | -
`-optdll` `option` | pass `option` to the DLL generator | dynamic | -
`-optwindres` `option` | pass `option` to `windres`. | dynamic | -

### 4.20.25. Platform-specific options

Section 4.16, “Platform-specific Flags”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-msse2` | (x86 only) Use SSE2 for floating point | dynamic | -
`-monly-[432]-regs` | (x86 only) give some registers back to the C compiler | dynamic | -

### 4.20.26. External core file options

Section 4.18, “Generating and compiling External Core Files”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-fext-core` | Generate `.hcr` external Core files | dynamic | -

### 4.20.27. Compiler debugging options

Section 4.19, “Debugging the compiler”

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-dcore-lint` | Turn on internal sanity checking | dynamic | -
`-ddump-to-file` | Dump to files instead of stdout | dynamic | -
`-ddump-asm` | Dump assembly | dynamic | -
`-ddump-bcos` | Dump interpreter byte code | dynamic | -
`-ddump-cmm` | Dump C-- output | dynamic | -
`-ddump-core-stats` | Print a one-line summary of the size of the Core program at the end of the optimisation pipeline | dynamic | -
`-ddump-cpranal` | Dump output from CPR analysis | dynamic | -
`-ddump-cse` | Dump CSE output | dynamic | -
`-ddump-deriv` | Dump deriving output | dynamic | -
`-ddump-ds` | Dump desugarer output | dynamic | -
`-ddump-flatC` | Dump “flat” C | dynamic | -
`-ddump-foreign` | Dump `foreign export` stubs | dynamic | -
`-ddump-hpc` | Dump after instrumentation for program coverage | dynamic | -
`-ddump-inlinings` | Dump inlining info | dynamic | -
`-ddump-llvm` | Dump LLVM intermediate code | dynamic | -
`-ddump-occur-anal` | Dump occurrence analysis output | dynamic | -
`-ddump-opt-cmm` | Dump the results of C-- to C-- optimising passes | dynamic | -
`-ddump-parsed` | Dump parse tree | dynamic | -
`-ddump-prep` | Dump prepared core | dynamic | -
`-ddump-rn` | Dump renamer output | dynamic | -
`-ddump-rule-firings` | Dump rule firing info | dynamic | -
`-ddump-rule-rewrites` | Dump detailed rule firing info | dynamic | -
`-ddump-rules` | Dump rules | dynamic | -
`-ddump-vect` | Dump vectoriser input and output | dynamic | -
`-ddump-simpl` | Dump final simplifier output | dynamic | -
`-ddump-simpl-phases` | Dump output from each simplifier phase | dynamic | -
`-ddump-simpl-iterations` | Dump output from each simplifier iteration | dynamic | -
`-ddump-spec` | Dump specialiser output | dynamic | -
`-ddump-splices` | Dump TH spliced expressions, and what they evaluate to | dynamic | -
`-ddump-stg` | Dump final STG | dynamic | -
`-ddump-stranal` | Dump strictness analyser output | dynamic | -
`-ddump-strsigs` | Dump strictness signatures | dynamic | -
`-ddump-tc` | Dump typechecker output | dynamic | -
`-ddump-types` | Dump type signatures | dynamic | -
`-ddump-worker-wrapper` | Dump worker-wrapper output | dynamic | -
`-ddump-if-trace` | Trace interface files | dynamic | -
`-ddump-tc-trace` | Trace typechecker | dynamic | -
`-ddump-vt-trace` | Trace vectoriser | dynamic | -
`-ddump-rn-trace` | Trace renamer | dynamic | -
`-ddump-rn-stats` | Renamer stats | dynamic | -
`-ddump-simpl-stats` | Dump simplifier stats | dynamic | -
`-dno-debug-output` | Suppress unsolicited debugging output | static | -
`-dppr-debug` | Turn on debug printing (more verbose) | static | -
`-dppr-noprags` | Don't output pragma info in dumps | static | -
`-dppr-user-length` | Set the depth for printing expressions in error msgs | dynamic | -
`-dppr-colsNNN` | Set the width of debugging output. For example `-dppr-cols200` | dynamic | -
`-dppr-case-as-let` | Print single alternative case expressions as strict lets. | dynamic | -
`-dsuppress-all` | In core dumps, suppress everything (except for uniques) that is suppressible. | dynamic | -
`-dsuppress-uniques` | Suppress the printing of uniques in debug output (easier to use diff) | dynamic | -
`-dsuppress-idinfo` | Suppress extended information about identifiers where they are bound | dynamic | -
`-dsuppress-module-prefixes` | Suppress the printing of module qualification prefixes | dynamic | -
`-dsuppress-type-signatures` | Suppress type signatures | dynamic | -
`-dsuppress-type-applications` | Suppress type applications | dynamic | -
`-dsuppress-coercions` | Suppress the printing of coercions in Core dumps to make them shorter | dynamic | -
`-dsource-stats` | Dump haskell source stats | dynamic | -
`-dcmm-lint` | C-- pass sanity checking | dynamic | -
`-dstg-lint` | STG pass sanity checking | dynamic | -
`-dstg-stats` | Dump STG stats | dynamic | -
`-dverbose-core2core` | Show output from each core-to-core pass | dynamic | -
`-dverbose-stg2stg` | Show output from each STG-to-STG pass | dynamic | -
`-dshow-passes` | Print out each pass name as it happens | dynamic | -
`-dfaststring-stats` | Show statistics for fast string usage when finished | dynamic | -

### 4.20.28. Misc compiler options

Flag | Description | Static/Dynamic | Reverse
--- | --- | --- | ---
`-j `N`` | When compiling with `--make`, compile `N` modules in parallel. | dynamic | -
`-fno-hi-version-check` | Don't complain about `.hi` file mismatches | static | -
`-dno-black-holing` | Turn off black holing (probably doesn't work) | static | -
`-fhistory-size` | Set simplification history size | dynamic | -
`-funregisterised` | Unregisterised compilation (use `-unreg` instead) | static | -
`-fno-ghci-history` | Do not use the load/store the GHCi command history from/to `ghci_history`. | dynamic | -
`-fno-ghci-sandbox` | Turn off the GHCi sandbox. Means computations are run in the main thread, rather than a forked thread. | dynamic | -

Prev | Up | Next
4.19. Debugging the compiler | Home | Chapter 5. Profiling